import java.net.*;
import java.math.*;
import java.io.*;


public class UDPClient{
    
   public static void main(String args[]){ 
    
       // arguments to main coLgntain
       // Arg 1: the destination hostname or IP
       // Arg 2: the destination well-known port
       // Arg 3: how many repeats

       int	transmissionTimeout	= 5000;
       boolean  timeout;
       int      messagesize		= 64; 
       long[]   Latenz			= new long[200];
       double   mittlereLatenz		= 0;
       int      anzahlWerte		= 0;
       long     min,max			= 0;

       if (args.length!=3) {
          System.out.println("Usage: UDPClient hostname port repeats\n"); System.exit(1);
       } 

	int serverPort = Integer.parseInt(args[1]);
        int repeats    = Integer.parseInt(args[2]);

	// fill array with nonsense
	for (int j=1;j<=repeats;j++) { Latenz[j] = -1; }

	DatagramSocket aSocket = null;

	try {
       
	    // create a datagram socket
	    aSocket = new DatagramSocket();

	    // set blocking timeout to 5000 millisec.
	    aSocket.setSoTimeout(5000);

	    byte[] m      = new byte[65536];
	    byte[] buffer = new byte[65536];

	    InetAddress aHost = InetAddress.getByName(args[0]);

	  
	    for (int i=1;i<=11;i++) {

		// increase messagesize
		if (i >1)  { messagesize = 2*messagesize; }
		if (i==11) { messagesize = 40000; }
	    
    		// create request datagram
    	        DatagramPacket request = new DatagramPacket(m,  messagesize, aHost, serverPort);
    
	        System.out.println("\nsend ("+messagesize+" bytes)...\n-----------------------------------------------------");



	        // for messagesize=64 to 65536 do...
        	for (int j=1;j<=repeats;j++) {



			// get the current time in milliseconds...	    
			long date1 = System.currentTimeMillis();

			// send message
			aSocket.send(request);

			// create new datagram to store the echoed message from the server
			DatagramPacket reply = new DatagramPacket(buffer, buffer.length);

			// receive the server's echo or process timeout exception
			timeout = false;
			try {
			    aSocket.receive(reply);
    			} catch (IOException e) {
			    timeout = true;
			    System.out.print("lost\t");
			}
	     
			// calculate the delay
  			if (!timeout) {
			    long date2  = System.currentTimeMillis();
    			    Latenz[j-1] = date2-date1;
    			    System.out.print(Latenz[j-1]+"ms\t");
    			}


		}

		//calculate var mittlereLatenz	    
		anzahlWerte	= 0;
		min		= 1000;
	        max		= 0;
    	        mittlereLatenz	= -1;

		for (int j=1;j<=repeats;j++) {

		    if (Latenz[j-1] != -1) {
        		mittlereLatenz += Latenz[j-1];
			if (Latenz[j-1]<min) { min = Latenz[j-1]; }
			if (Latenz[j-1]>max) { max = Latenz[j-1]; }
        		anzahlWerte++;
			Latenz[j-1]   = -1;
		    }
	      
		}  


		mittlereLatenz = mittlereLatenz/anzahlWerte;
      
		System.out.println("\n-----------------------------------------------------");
		System.out.println("min "+min+"ms, max "+max+"ms, average "+mittlereLatenz+"ms ("+anzahlWerte+" values)");
	    
	    }

	} catch (SocketException e){System.out.println("Socket: " + e.getMessage());
	} catch (IOException e){System.out.println("IO: " + e.getMessage());
	} finally {if(aSocket != null) aSocket.close();}

	System.out.println();

    }
}
