package VoE;

/* (k) 2005 by ahzf voe@ahzf.de */

import java.io.*;
import java.net.*;
import java.util.*;
import java.util.StringTokenizer;
import java.util.List;
import java.util.Iterator;
import java.util.Timer;
import java.util.HashMap;
import java.io.File;
import VoE.*;



class VoE_CommServer {


    protected static String      Version              = "0.1";
    protected static int         localPort            = 2305;
    protected static int         maxInstances         = 10;
    protected static int         timeout              = 300000;

    /* 2b verbose || !2b verbose */
    protected static int         talking              = 1;
    protected static boolean     talkingCLIOverwrite  = false;

    /* Where worker threads stand idle */
              static Vector      threadPool           = new Vector();
              static int         threadCounter        = 1;

    protected static PrintStream log                  = null;
    protected static VoE_CommServer_SessionComm		VoE_SessionComm;
   



    public static void UserIO(int myTalking, String line) {
      if (talking >= myTalking) { System.out.println(line); }
    }


    /* print to the log file */
    protected static void log(String s) {
      synchronized (log) {
        log.println(s);
        log.flush();
      }
    }



    public static void main(String[] a) throws Exception {

      VoE_SessionComm = new VoE_CommServer_SessionComm();
      (new Thread(VoE_SessionComm, "commWorker")).start();

      /* start worker threads */
      for (int i=0; i<maxInstances; ++i) {
        VoE_CommServerThread w = new VoE_CommServerThread(threadCounter);
        (new Thread(w, "worker #"+threadCounter++)).start();
        threadPool.addElement(w);
      }

      ServerSocket ss = new ServerSocket(localPort);


      while (true) {

        Socket                clientSocket	= ss.accept();
        VoE_CommServerThread  w			= null;
        System.out.println("new connection from "+clientSocket.getInetAddress()+", port "+clientSocket.getPort());

        synchronized (threadPool) {
          if (threadPool.isEmpty()) {
            VoE_CommServerThread ws = new VoE_CommServerThread(threadCounter);
            ws.setSocket(clientSocket);
            (new Thread(ws, "worker #"+threadCounter++)).start();
          } else {
            w = (VoE_CommServerThread) threadPool.elementAt(0);
            threadPool.removeElementAt(0);
            w.setSocket(clientSocket);
          }
        }


      }

    }

}



