package VoE;

/* (k) 2005 by ahzf voe@ahzf.de */

import java.net.*;
import java.io.*;
import java.util.Vector;
import VoE.*;


public class VoE_EchoServerThread implements Runnable {

  protected	int			threadCounter	= 0;
  protected	String			serverProtocol	= "nix";
  protected	int			serverPort	= 0;
  protected	DatagramSocket		serverSocket	= null;
  protected	byte[]			buffer		= null;
  protected	boolean			initError	= false;
  protected	Vector			users		= new Vector();
  protected	boolean			stopServer	= false;



  public VoE_EchoServerThread(int counter, int port, String user, String protocol) {

    this.serverPort		= port;
    this.threadCounter		= counter;
    this.serverProtocol		= protocol;

    if (serverPort>0 && serverPort<65536) {
      this.buffer		= new byte[65536];
      this.users.addElement(user);
    } else {
      initError			= true;
      System.out.println(serverProtocol+"EchoServer on port "+serverPort+": Init Error in constructor");
    }

  }



  public boolean isValid() {
    if (serverSocket == null || initError) {
      if (serverSocket == null) System.out.println(serverProtocol+"EchoServer on port "+serverPort+": serverSocket == null");
      if (initError)            System.out.println(serverProtocol+"EchoServer on port "+serverPort+": initError == true");
      return(false);
    } else {
      return(true);
    }
  }



  public void addUser(String user) {
    synchronized (users) {
      if (!users.contains(user)) {
        this.users.addElement(user);
        System.out.println(serverProtocol+"EchoServer on port "+serverPort+" usageCount: "+this.users.size());
      } else {
        System.out.println(serverProtocol+"EchoServer on port "+serverPort+" already up'n'running");
      }
    }
  }



  public boolean stopServer(String user) {

//    synchronized (users) {

      this.users.removeElement(user);
      System.out.println(serverProtocol+"EchoServer on port "+serverPort+" usageCount: "+this.users.size());

      if (this.users.size() == 0) {
        System.out.println("--> will stop the server");
//        stopServer = true;
//        if(serverSocket != null) serverSocket.close();
        return(true);
      } else {
        return(false);
      }

//    }

  }



  public void killServer() {
    try {
      if(serverSocket != null) serverSocket.close();
    } catch (Exception e) {
    }
  }



  public void run() {

//    try{
//
//      while(true){
//
//        DatagramPacket request = new DatagramPacket(buffer, buffer.length);
//        serverSocket.receive(request);
//
//        DatagramPacket reply   = new DatagramPacket(request.getData(), request.getLength(), request.getAddress(), request.getPort() );
//        serverSocket.send(reply);
//
//      }
//
//    } catch (SocketException e) {
//      System.out.println(serverProtocol+"EchoServer on port "+serverPort+": " + e.getMessage());
//
//    } catch (IOException e) {
//      System.out.println(serverProtocol+"EchoServer on port "+serverPort+": " + e.getMessage());
//
//    } finally {
//      if(serverSocket != null) serverSocket.close();
//      System.out.println(serverProtocol+"EchoServer on port "+serverPort+" finally stopped");
//    }
//
//    System.out.println(serverProtocol+"EchoServer on port "+serverPort+" stopped");
//
  }


}
