package VoE;

/* (k) 2005 by ahzf voe@ahzf.de */

import java.net.*;
import java.io.*;
import java.util.Vector;
import VoE.*;


public class VoE_UDPEchoServerThread implements Runnable {

  private int			threadCounter	= 0;
  private int			serverPort	= 0;
  private DatagramSocket	serverSocket	= null;
  private byte[]		buffer		= null;
  private boolean		initError	= false;
  private Vector		users		= new Vector();
  private boolean		stopServer	= false;



  public VoE_UDPEchoServerThread(int counter, int port, String user) {

    this.serverPort		= port;
    this.threadCounter		= counter;

    // create a new UDP socket at a well known UDP-port
    try {

      if (serverPort>0 && serverPort<65536) {

        this.serverSocket	= new DatagramSocket(this.serverPort);
        this.buffer		= new byte[65536];

        this.users.addElement(user);
        System.out.println("UDPEchoServer on port "+serverPort+" started");

      } else {
        initError		= true;
      }

    } catch (SocketException e) {
      initError = true;
    }


  }



  public boolean isValid() {
    if (serverSocket == null || initError) {
      return(false);
    } else {
      return(true);
    }
  }



  public void addUser(String user) {
    synchronized (users) {
      if (!users.contains(user)) {
        this.users.addElement(user);
        System.out.println("UDPEchoServer on port "+serverPort+" usageCount: "+this.users.size());
      } else {
        System.out.println("UDPEchoServer on port "+serverPort+" already up'n'running");
      }
    }
  }



  public boolean stopServer(String user) {

//    synchronized (users) {

      this.users.removeElement(user);
      System.out.println("UDPEchoServer on port "+serverPort+" usageCount: "+this.users.size());

      if (this.users.size() == 0) {
        System.out.println("--> will stop the server");
//        stopServer = true;
//        if(serverSocket != null) serverSocket.close();
        return(true);
      } else {
        return(false);
      }

//    }

  }



  public void killServer() {
    if(serverSocket != null) serverSocket.close();
  }



  public void run() {

    try{

      while(true){

        DatagramPacket request = new DatagramPacket(buffer, buffer.length);
        serverSocket.receive(request);

        DatagramPacket reply   = new DatagramPacket(request.getData(), request.getLength(), request.getAddress(), request.getPort() );
        serverSocket.send(reply);

      }

    } catch (SocketException e) {
      System.out.println("UDPEchoServer on port "+serverPort+": " + e.getMessage());

    } catch (IOException e) {
      System.out.println("UDPEchoServer on port "+serverPort+": " + e.getMessage());

    } finally {
      if(serverSocket != null) serverSocket.close();
      System.out.println("UDPEchoServer on port "+serverPort+" finally stopped");
    }

    System.out.println("UDPEchoServer on port "+serverPort+" stopped");

  }


}
